const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const subscriber_roles = sequelize.define(
    'subscriber_roles',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      role_name: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriber_roles.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.subscriber_roles.belongsTo(db.subscribers, {
      as: 'subscriber',
      foreignKey: {
        name: 'subscriberId',
      },
      constraints: false,
    });

    db.subscriber_roles.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.subscriber_roles.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriber_roles.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return subscriber_roles;
};
